(* uses src/missing
 *)

(* TODO: benchmark this if it is a fast set implementation *)

(*
 * A set implementation as predicate functions
 *)
structure FunSet =
struct
  datatype 'a set = S of 'a -> bool

  fun empty () = S (fn _ => false)

  fun addItem (S s) a =
    S (fn el => if el = a then true else (s el))

  fun remItem (S s) a =
    S (fn el => if el = a then false else (s el))

  fun union (S s) (S s') =
    S (fn el => s el orelse s' el)

  fun inter (S s) (S s') =
    S (fn el => s el andalso s' el)

  fun subs (S s) (S s') =
    S (fn el => s el andalso not (s' el))

  fun isIn (S s) a = s a

  fun fromList lst =
    foldr (fn (el, set) => addItem set el) (empty ()) lst

  fun toList set = Err.undefined ()
end;

