#!/bin/bash


function usage {
    echo "Usage: $COMMANDEXEC [-h] [-o outfile] file"
}

OUT=a.out
while getopts 'o:h' OPT; do
    case $OPT in
        h) usage; exit ;;
        o) OUT="$OPTARG"; shift;shift;;
    esac
done

PROGRAM=$1
[ -z "$PROGRAM" ] && \
    echo "Please provide a program name, see -h for usage info." && exit 1


# Exit if any of the following programs exits with non-zero exit status
set -e

(cat <<END
PolyML.export("$OUT", start);
END
) | "$TOOLSPATH/uses.sh" -i "@$PROGRAM"

gcc -o "$OUT" "$OUT.o" -lpolymain -lpolyml


