#!/bin/bash

#
# The script expects PSI_WORKBENCH_HOME to be properly defined
#

. "$PSI_WORKBENCH_HOME/tools/common.sh"
INTERACTIVE=no


function help {
    cat <<END
Usage: $COMMANDEXEC [-h] [-i] uses/path/spec ...

    -h  prints this help message
    -i  lands the SML interpreter into interactive mode
END
}


while getopts 'ih' OPT; do
    case $OPT in
        h) help; exit ;;
        i) INTERACTIVE=yes; shift;;
    esac
done


(cat <<END
$SML_QUITE_OUTPUT
structure PsiWorkBenchHome = struct val home = "$PSI_WORKBENCH_HOME/" end;
use "$PSI_WORKBENCH_HOME/src/missing.ML";
use "$PSI_WORKBENCH_HOME/src/parser.ML";
use "$PSI_WORKBENCH_HOME/tools/uses.ML";
val uses = Uses.uses;
END

for f in "$@"; do echo -e "uses \"$f\";\n"; done;

echo "$SML_RESTORE_NORMAL_OUTPUT"

[ $INTERACTIVE = yes ] && cat
) | $SML $SML_OPTS


